# Config Part
#
#######################

$data_dir = "data"; # data directory like "data"
$unknowncmd_msg = "unknown command"; # msg when command is unknown
$unknownnick_msg = "unknown nickname"; # msg when nickname is unknown
$help_msg= << "[END]"; # msg printed on /help (DON'T REMOVE "[END]")
    <I><B>commands:</B></I><BR>
    /msg <KBD>nickname</KBD> <KBD>message</KBD> - send private <KBD>message</KBD> to <KBD>nickname</KBD><BR>
    /help - this helptext<BR>
    /about - about this program<BR>
    /me - action (eg "/me says hello" will appear as "* user says hello")<BR>
    /userinfo <KBD>nick</KBD> - userinfo about (offline) user<BR>
	/memo <KBD>nick message</KBD> - leave message for offline user<BR><BR>
    <I><B>master commands:</B></I><BR>    
    /list_nicks <KBD>masterpassword</KBD> - list all users (online or not)<BR>
    /clean_old_nicks <KBD>masterpassword x</KBD> - remove all users who haven\'t visited the chat for <KBD>x</KBD> days<BR>
    /remove_nick <KBD>masterpassword nick</KBD> - remove <KBD>nick</KBD><BR>
    /ban <KBD>masterpassword nick</KBD> - ban user from chatroom<BR>
    /ban <KBD>masterpassword</KBD> ip:<KBD>x.x.x.x</KBD> - ban ip from chatroom (works only when user with banned ip enters, you have to kick/ban the user manually, too)<BR>
    /kick <KBD>masterpassword nick</KBD> - kick user out of the chat<BR>
    /unban <KBD>masterpassword nick</KBD> - unban user<BR>
    /unban <KBD>masterpassword</KBD> ip:<KBD>x.x.x.x</KBD> - unban ip<BR>
[END]
$welcome_msg = << "[END]"; # msg printed when user logs in
    Welcome to Ralfs Chat!<BR>
    /help - helptext
[END]
$masterpassword = "mpw"; # Masterpassword for special commands
$wrongmasterpass_msg = "wrong masterpassword"; # msg printed when wrong mpw was used at a special cmd
$updatefrequency = 5; # number of seconds the chat updates itself
$clear_old_msgs = 1; # set to 1 if you want that old msgs are deleted when the chat is empty
$nocleantime_msg = "no number of days specified"; # if no number of days in /clean_old_nicks is given
$message_limit = 20; # number of maximal (public) messages in the chat window
$new_msg_on_top = 0; # set to 1 if you want new messages printed on top, to work around the msie bug
$admin_email_addresse = "you\@yourserver.com"; # Your email address (replace @ with \@)
$mailprogramme = '/usr/sbin/sendmail'; # Path to the mail-transport-agent
$mail_on_new_registration = 0; # set to 1 if you want to be mailed when a new user registers
$logtype = 0; # The type of log you wish: 0 - no log, 1 - registrations, 2 - +logins, 3 - +messages
$log_dir = "logs"; # directory for log files
$script_name = "chat.cgi"; # filename of the script like "chat.cgi"
$script2_name = "chat2.cgi"; # filename of the second cript like "chat2.cgi"
$max_users = "-1"; # the maximal number of users in the chat at the same time, set to "-1" if unlimited
$login_msg = "has entered the chat"; # MSG printed when user logs in without "user"
$logout_msg = "has left the chat"; # MSG printed when user logs out without "user"
$days_to_keep_memos = 60; # Number of days to keep memos
$min_update_freq = 2; # the minimum update frequency
$reset_private_msg_select = 0; # set to 1 if you want the select field for private msgs to be reset to "to all users" after msg was sent NEW

# Files - don't need to be changed, only if you want several script
# using eg the same nick file but different msg file. So you can use
# the script for multiple chat rooms.

$data_msg_file = "messages";
$data_stillalive_file = "stillalive";
$data_private_file = "private"; # without .user
$data_nicks_file = "nicks"; # you should leave this one, else the user has to register on every single script
$data_userinfo_file = "userinfo"; # the user-info database
$data_banned_file = "banned"; # banned user file
$data_memo_file = "memo"; # memo file

# HTML-Stuff

$html_bodytag = '<BODY BGColor=#000000 TEXT=#6699FF Link=#0000FF VLINK=#0000CC ALINK=#0000FF>'; # The bodytag for html files
$html_title = "WOscripts - Ralfs Chat"; # The title of your chat
$banner_picture = "http://www.woscripts.com/images/88x31.gif"; # the banner picture, set to "" if you dont want any banner
$banner_link = "http://www.woscripts.com"; # The banner link
$logout_url = "$script_name"; # the url for the logout-link
$input_field_size = "30"; # the size of the msg input field

# END CONFIG PART - ALL DONE
#
########################

# HTML Part
#
########################


#NONICK.HTML - when nick doesnot exists
sub nonick_html {
	print <<"[END]";
<HTML>
<HEAD><TITLE>$html_title - Nick doesn't exist</TITLE>
</HEAD>
$html_bodytag
<CENTER>
<H1><I>Nick doesn't exist</I></H1>
<B><A HREF="$script2_name?action=register">register</A> or<BR>
<A HREF="$script_name">try another nick</A></B>
</CENTER>
</BODY>
</HTML>
[END]
}

#WRONGPASS.HTML - when wrong password was entered
sub wrongpass_html {
	print <<"[END]";
<HTML>
<HEAD><TITLE>$html_title - Wrong Password</TITLE>
</HEAD>
$html_bodytag
<CENTER>
<H1><I>Wrong Password</I></H1>
<B><A HREF="$script2_name?action=send_pwd&name=$query{'name'}">lost password</A></B><BR>
<B><A HREF="$script_name">retry</A></B>
</CENTER>
</BODY>
</HTML>
[END]
}

#KICKED.HTML - when user is kicked
sub kicked_html {
	print <<"[END]";
<HTML>
<HEAD><TITLE>$html_title - You were kicked</TITLE>
</HEAD>
$html_bodytag
<CENTER>
<H1><I>You were kicked</I></H1>
<B><A HREF="$script2_name?action=gotourl&url=$logout_url" TARGET="_parent">logout</A></B>
</CENTER>
</BODY>
</HTML>
[END]
}

#BANNED.HTML - when user is banned
sub banned_html {
	print <<"[END]";
<HTML>
<HEAD><TITLE>$html_title - You are banned</TITLE>
</HEAD>
$html_bodytag
<CENTER>
<H1><I>You are banned</I></H1>
<B><A HREF="$script2_name?action=gotourl&url=$logout_url" TARGET="_parent">logout</A></B>
</CENTER>
</BODY>
</HTML>
[END]
}

# Main Part - DON'T CHANGE ANYTHING HERE!
#
#######################

$version = "0.11.2";     # don't change
$lastmodified = "26.11.99"; # don't change
$about_msg = "Ralfs Chat - <A HREF=\"$script2_name?action=gotourl\&url=http://www.ralfchat.de\" TARGET=\"ralfchat\">www.ralfchat.de</A> -  created and copyright by Ralf Gueldemeister \&lt;ralf\@ralfchat.de> on 25.12.98; last modified on $lastmodified; Version $version"; # msg printed on /about

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$mon++; $year += 1900;
$log_file = "$year-$mon-$mday.txt";

&getquery;

sub extract_qs { # einzelne variablen aus query_string extrahieren und in hash $query uebergeben
	my @split = split (/&/, $qs);
	foreach $split (@split) {
		($query_key, $query_value) = split (/=/, $split);
		$query_value =~ tr/+/ /;
		$query_value =~ s/%([\dA-Fa-f][\dA-Fa-f])/ pack ("C", hex ($1))/eg;
		$query{$query_key} = $query_value;	
	}

}

sub getquery {
	if ($ENV{'REQUEST_METHOD'} eq "GET") {
		$qs= $ENV{'QUERY_STRING'}; # Wert vom query_string wird in $qs gespeichert
	} elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
		read(STDIN, $qs, $ENV{'CONTENT_LENGTH'});
	}
	&extract_qs; # einzelne variablen aus querystring auslesen
}

sub header { # Gibt standard html header aus
	print "Content-type: text/html\n\n";
}

sub error { # Irgendein Fehler ist aufgetreten
	&header;
	print "<H1>An error occured</H1>";
	print "<I>Query_String:</I> $qs<BR>";
	print "<I>Errormessage:</I> $_[0]";
	exit;
}


sub repair_safile {
	my $i=0;
	my @satemp;
	my @satemp2;
	for (@sa) {        
		if (/[A-Za-z]/) {
			$satemp[$i]=$_;
			$i++;
		}
	}    
	$i=0;
	@sa = "";
	for (@satemp) {
		$sa[$i*2] = $satemp[$i];
		$sa[$i*2+1] = time;
		$i++; 
	}

	@sa = "" if ($#sa % 2 == 0);
}

sub checkpass {
	if (-e "$data_dir/$data_nicks_file") {  # wenn nickfile existiert dann oeffnen
		open (NICKFILE, "<$data_dir/$data_nicks_file") || &error("::open Nickfile failed::");
	} 
	else {  # else print nonick_html
		&header;
		&nonick_html;
		exit;
	}
	my @nickfile = <NICKFILE>; 
	close NICKFILE; 

	my @nickfile_matrix = ();

	for (my $i = 0; $i <= $#nickfile; $i++) {
		chomp($nickfile[$i]);
		push(@nickfile_matrix, [split(/;;/, $nickfile[$i])]);
	}
	
	my $nickok;
	for (my $cpi=0; $cpi<=$#nickfile_matrix; $cpi++) {
		if ($nickfile_matrix[$cpi][0] eq $query{'name'}) {
			$nickok = 1;
			if ($nickfile_matrix[$cpi][1] ne $query{'password'}) {
				&header;
				&wrongpass_html;
				exit;
			}
			if ($nickfile_matrix[$cpi][10] == 1) {
				&header;
				&kicked_html;
				exit;
			}
			if ($nickfile_matrix[$cpi][10] == 2) {
				&header;
				&banned_html;
				exit;
			}
		} 
	}

	if ($nickok != 1) {
		&header;
		&nonick_html;
		exit;
	}

}

sub postprivatemsg { # parameter: 0: empfaenger 1: sender 2: msg 
	&checkpass;  # Passwort checken

	# kill linebreaks
	$_[2] =~ s/\n/ /g;

	if (-e "$data_dir/$data_private_file.$_[0]") {
	} else {
		&postprivatemsg($query{'name'}, "MSG", "$unknownnick_msg: $_[0]");
		return;
	}

	# alte Eintraege >35 loeschen
	open (PRIVATEFILE, "<$data_dir/$data_private_file.$_[0]") || &error("opening $data_dir/$data_private_file.$_[0] failed");
	my @privatefile = <PRIVATEFILE>;
	close PRIVATEFILE;

	for (my $ppm_i=0; $ppm_i <= ($#privatefile -35); $ppm_i++) {
		shift(@privatefile);
	}
	open (PRIVATEFILE, ">$data_dir/$data_private_file.$_[0]") || &error("opening privatefile failed");
	flock(PRIVATEFILE,2);

	print PRIVATEFILE @privatefile;

	close PRIVATEFILE;

	while (time == $last_priv_msg_id) {}
	$priv_msg_id = time;
	$last_priv_msg_id = $priv_msg_id;

	open (PRIVATEFILE, ">>$data_dir/$data_private_file.$_[0]");
	flock(PRIVATEFILE,2);

	if ($query{'color'} eq "standard") {
		print PRIVATEFILE "$priv_msg_id;;<B>[$_[1]]</B> $_[2]\n";
	} else {
	print PRIVATEFILE "$priv_msg_id;;<FONT COLOR=\"$query{'color'}\"><B>[$_[1]]</B> $_[2]</FONT>\n";
	}        

	close PRIVATEFILE;

	open (CHATFILE, ">>$data_dir/$data_msg_file");
	flock(CHATFILE,2);

	print CHATFILE "<!--PrivateMsgHere;;$_[0];;$priv_msg_id;;-->";

	close CHATFILE;
}

sub create_file { # Datei erstellen (in Klammern als parameter zu uebergeben)
	my $file2create = $_[0];
	open (CREATEFILE, ">$file2create") || &error("creating $file2create failed");
	close (CREATEFILE);
}

sub userinfo {
	open (UIFILE, "<$data_dir/$data_userinfo_file") || &create_file("$data_dir/$data_userinfo_file");
	my @uifile = <UIFILE>; 
	close UIFILE;

	my @uifile_matrix = ();

	for (my $i = 0; $i <= $#uifile; $i++) {
		chomp($uifile[$i]);
		push(@uifile_matrix, [split(/;;/, $uifile[$i])]);
	}
	
	my $nickfound = 0;
	for (my $i=0; $i<=$#uifile_matrix; $i++) {
		if ($uifile_matrix[$i][0] eq $query{'infoabout'}) {
			$userinfo{'realname'} = $uifile_matrix[$i][1];
			$userinfo{'email'} = $uifile_matrix[$i][2];
			$userinfo{'age'} = $uifile_matrix[$i][3];
			$userinfo{'city'} = $uifile_matrix[$i][4];
			$userinfo{'country'} = $uifile_matrix[$i][5];
			$userinfo{'url'} = $uifile_matrix[$i][6];
			$userinfo{'stuff'} = $uifile_matrix[$i][7];
			$userinfo{'photo_url'} = $uifile_matrix[$i][8];
			$userinfo{'icq_uin'} = $uifile_matrix[$i][9];
			$nickfound = 1;
		}
	}

	if ($userinfo_as_private_msg != 1) {
		&header;
		&userinfo_html;
	} elsif ($nickfound == 0){
		&postprivatemsg($query{'name'}, "USERINFO", "user $query{'infoabout'} not found");
	} else {
		&postprivatemsg($query{'name'}, "USERINFO", "<B>$query{'infoabout'}</B><BR>realname: $userinfo{'realname'}<BR>email: <A HREF=\"mailto:$userinfo{'email'}\">$userinfo{'email'}</A><BR>age: $userinfo{'age'}<BR>city: $userinfo{'city'}<BR>country: $userinfo{'country'}<BR>homepage: <A HREF=\"$userinfo{'url'}\">$userinfo{'url'}</A><BR>anything else: $userinfo{'stuff'}<BR>photo: <A HREF=\"$userinfo{'photo_url'}\">$userinfo{'photo_url'}</A>");
	}
}

1;
